#!/usr/bin/python3.10
from modules.driver_tools import *
from modules.imports import *
import modules.globals as g
import json


class FakeWebHook:
    def send(self, text="", username='', avatar_url='', embed="", file=""):
        print(text)


parser = argparse.ArgumentParser()

parser.add_argument(
    "-c",
    "--config",
    help="Choose a specific config file",
    default=""
)

parser.add_argument(
    "-v",
    "--vnc",
    help="enable VNC",
    dest="vnc"
)

parser.add_argument(
    "--version",
    help="display a message on discord to tell that the bot have been updated",
    dest="update_version",
    default="None"
)

parser.add_argument(
    "--json",
    help="input json to start the bot with custom parameters",
    default=""
)

with open("/app/MsRewards-Reborn/user_data/discord.json", "r") as inFile:
    discord = json.load(inFile)
with open("/app/MsRewards-Reborn/user_data/settings.json", "r") as inFile:
    settings = json.load(inFile)
with open("/app/MsRewards-Reborn/user_data/proxy.json", "r") as inFile:
    proxy = json.load(inFile)
with open("/app/MsRewards-Reborn/user_data/configs.json", "r") as inFile:
    config = json.load(inFile)

args = parser.parse_args()

g.json_start = args.json

g.vnc_enabled = args.vnc != "None"
g.vnc_port = args.vnc
g.update_version = args.update_version
# global variables used later in the code

g.start_time = time()

# path configurations
g.mot_path = "/usr/share/dict/french"
g.credential_path = "/app/MsRewards-Reborn/user_data/login.csv"

discord_conf = config[args.config]["discord"]

# discord configuration
g.discord_success_link = discord[discord_conf]["successL"]
g.discord_error_link = discord[discord_conf]["errorsL"]
g.discord_enabled_error = discord[discord_conf]["errorsT"] == "True"
g.discord_enabled_success = discord[discord_conf]["successT"] == "True"

g.avatar_url = settings["avatarlink"]

if not g.json_start:
    if g.discord_enabled_error:
        webhookFailure = Webhook.from_url(g.discord_error_link, adapter=RequestsWebhookAdapter())
    if g.discord_enabled_success:
        webhookSuccess = Webhook.from_url(g.discord_success_link, adapter=RequestsWebhookAdapter())
else:
    webhookFailure = FakeWebHook()
    webhookSuccess = FakeWebHook()


# base settings
g.discord_embed = False  # send new point value in an embed, fixed for now
g.headless = False

# proxy settings
g.proxy_enabled = config[args.config]["proxy"] != "-1"
if g.proxy_enabled:
    g.proxy_address = proxy[config[args.config]["proxy"]]["address"]
    g.proxy_port = proxy[config[args.config]["proxy"]]["port"]


# list of words
with open(g.mot_path, "r", encoding="utf-8") as h:
    lines = h.readlines()
    if len(lines) < 3:
        Liste_de_mot = list(lines[0].split(","))
    else:
        Liste_de_mot = [x.replace('\n', "") for x in lines]


if g.proxy_enabled:
    setup_proxy(g.proxy_address, g.proxy_port)
